
; ========================================================
;			
;    -- ButtOn.asm --
;			Jay Sullivan
; ========================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include ButtOn.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
		
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND


	;------------------------------------------------
	;	Main Window Class
	;------------------------------------------------
		
		mov wc.cbSize, Sizeof WNDCLASSEX
		mov wc.style, CS_HREDRAW or CS_VREDRAW 
		mov wc.lpfnWndProc, Offset WndProc
		mov wc.cbClsExtra,NULL
		mov wc.cbWndExtra,NULL
		mov eax,hInst
		mov wc.hInstance,eax
		mov wc.hbrBackground, COLOR_WINDOW+12
		mov wc.lpszMenuName, NULL
		mov wc.lpszClassName, Offset ClassName
		invoke LoadIcon, NULL,IDI_HAND
		mov wc.hIcon,eax
		mov wc.hIconSm,0
		invoke LoadCursor, NULL, IDC_ARROW
		mov wc.hCursor,eax
		invoke RegisterClassEx, ADDR wc
		;invoke LoadMenu, hInst, Offset MenuName
		;mov hMenu,eax
		
	;------------------------------------------------
	;	Windows
	;------------------------------------------------
		invoke buttRegisterClass
		;-----------------------------
		;	Main Window
		;-----------------------------
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW,\
				CW_USEDEFAULT,CW_USEDEFAULT,200,130,\
				NULL,hMenu,hInst,NULL
			mov hwnd,eax
				
			EDITFLAGS equ WS_VISIBLE or WS_CHILD or ES_LEFT 
			
			invoke CreateWindowEx, 0 , ADDR buttClassName, 0, EDITFLAGS, 0,   0,55,35, hwnd,0,hInst,0
			mov Butt1,eax
			invoke CreateWindowEx, 0 , ADDR buttClassName, 0, EDITFLAGS, 60,  0,55,35, hwnd,0,hInst,0
			mov Butt2,eax
			invoke CreateWindowEx, 0 , ADDR buttClassName, 0, EDITFLAGS, 120, 0,55,35, hwnd,0,hInst,0
			mov Butt3,eax
			invoke CreateWindowEx, 0 , ADDR buttClassName, 0, EDITFLAGS, 0,50,55,35, hwnd,0,hInst,0
			mov Butt4,eax
			invoke CreateWindowEx, 0 , ADDR buttClassName, 0, EDITFLAGS, 60,50,55,35, hwnd,0,hInst,0
			mov Butt5,eax
			invoke CreateWindowEx, 0 , ADDR buttClassName, 0, EDITFLAGS, 120,50,55,35, hwnd,0,hInst,0
			mov Butt6,eax
			
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	;-----------------------------
	 .if uMsg==WM_DESTROY
	;-----------------------------
		
		invoke PostQuitMessage, NULL
		
		
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP


ButtonData STRUCT
	state BOOL ?
	text DWORD ?
ButtonData ENDS

buttWndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL hdc:HDC,
	  oldBrush:HBRUSH,
	  myBrush:HBRUSH,
	  myData:DWORD, 
	  myRect:RECT, pss:PAINTSTRUCT
	;-----------------------------
	.if uMsg== WM_PAINT
	;-----------------------------
	push esi
		invoke GetWindowLong,hWnd,GWL_USERDATA
		mov esi, eax
		
		invoke BeginPaint,hWnd,ADDR pss
	 	mov hdc, eax
 	
 		mov eax, [esi].ButtonData.state
 		add eax, 2
	 	invoke GetStockObject, eax
	 	mov myBrush, eax
	 	
	 	invoke SelectObject,hdc, myBrush
		mov oldBrush, eax 
		
			invoke RoundRect,hdc,5,5,50,30,10,10
			
			
			invoke GetWindowRect,hWnd,ADDR myRect
			invoke DrawText, hdc, ADDR [esi].ButtonData.text,2,ADDR myRect,DT_SINGLELINE
				
	 	invoke SelectObject,hdc, oldBrush
	 	invoke EndPaint,hWnd,ADDR pss
	 	
	pop esi
	;-----------------------------
	 .elseif uMsg==WM_COMMAND
	;-----------------------------
		
		mov eax,wParam
		
		
	;-----------------------------
	.elseif uMsg== WM_MOUSEACTIVATE
	;-----------------------------
		invoke GetWindowLong,hWnd,GWL_USERDATA
		not [eax].ButtonData.state    ;   eax = NOT eax
		invoke InvalidateRect,hWnd,0,TRUE
	
	;-----------------------------
	.elseif uMsg== WM_CREATE
	;-----------------------------
		invoke GlobalAlloc,GMEM_ZEROINIT,Sizeof ButtonData
		mov [eax].ButtonData.text, 'ASDF'
		invoke SetWindowLong,hWnd,GWL_USERDATA,eax
	;-----------------------------
	 .elseif uMsg==WM_DESTROY
	;-----------------------------
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke GlobalFree,eax
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
buttWndProc ENDP

End Start